
// why are people still using Internet Explorer?!
/*! promise-polyfill 3.1.0 */
!function(a){function b(a,b){return function(){a.apply(b,arguments)}}function c(a){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof a)throw new TypeError("not a function");this._state=null,this._value=null,this._deferreds=[],i(a,b(e,this),b(f,this))}function d(a){var b=this;return null===this._state?void this._deferreds.push(a):void k(function(){var c=b._state?a.onFulfilled:a.onRejected;if(null===c)return void(b._state?a.resolve:a.reject)(b._value);var d;try{d=c(b._value)}catch(e){return void a.reject(e)}a.resolve(d)})}function e(a){try{if(a===this)throw new TypeError("A promise cannot be resolved with itself.");if(a&&("object"==typeof a||"function"==typeof a)){var c=a.then;if("function"==typeof c)return void i(b(c,a),b(e,this),b(f,this))}this._state=!0,this._value=a,g.call(this)}catch(d){f.call(this,d)}}function f(a){this._state=!1,this._value=a,g.call(this)}function g(){for(var a=0,b=this._deferreds.length;b>a;a++)d.call(this,this._deferreds[a]);this._deferreds=null}function h(a,b,c,d){this.onFulfilled="function"==typeof a?a:null,this.onRejected="function"==typeof b?b:null,this.resolve=c,this.reject=d}function i(a,b,c){var d=!1;try{a(function(a){d||(d=!0,b(a))},function(a){d||(d=!0,c(a))})}catch(e){if(d)return;d=!0,c(e)}}var j=setTimeout,k="function"==typeof setImmediate&&setImmediate||function(a){j(a,1)},l=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)};c.prototype["catch"]=function(a){return this.then(null,a)},c.prototype.then=function(a,b){var e=this;return new c(function(c,f){d.call(e,new h(a,b,c,f))})},c.all=function(){var a=Array.prototype.slice.call(1===arguments.length&&l(arguments[0])?arguments[0]:arguments);return new c(function(b,c){function d(f,g){try{if(g&&("object"==typeof g||"function"==typeof g)){var h=g.then;if("function"==typeof h)return void h.call(g,function(a){d(f,a)},c)}a[f]=g,0===--e&&b(a)}catch(i){c(i)}}if(0===a.length)return b([]);for(var e=a.length,f=0;f<a.length;f++)d(f,a[f])})},c.resolve=function(a){return a&&"object"==typeof a&&a.constructor===c?a:new c(function(b){b(a)})},c.reject=function(a){return new c(function(b,c){c(a)})},c.race=function(a){return new c(function(b,c){for(var d=0,e=a.length;e>d;d++)a[d].then(b,c)})},c._setImmediateFn=function(a){k=a},"undefined"!=typeof module&&module.exports?module.exports=c:a.Promise||(a.Promise=c)}(this);

define("qubdlui", ["d3"], function(d3) {
    var exports = {};
    var ui = {};
    var os = 'src'; //default
    var deferredFile = '';

    var osLabel = {
        'win': 'Download QUB apps for Windows',
        'lin': 'Download QUB packages for Linux (Debian/Ubuntu)',
        'mac': 'Download QUB apps for Mac OS X',
        'src': 'Download QUB source code'
    }
    var notice; // at bottom because the punctuation screws up emacs
    
    exports.start = function(config) {
        exports.node = config.node;
        ui.reg = exports.node.querySelector("#reg");
        ui.regName = reg.querySelector("#name");
        ui.regEmail = reg.querySelector("#email");
        ui.regWarn = reg.querySelector("#regwarn");
        ui.regBtn = reg.querySelector("#register");
        ui.conf = exports.node.querySelector("#regconf");
        ui.confName = ui.conf.querySelector("#confname");
        ui.confEmail = ui.conf.querySelector("#confemail");
        ui.rereg = ui.conf.querySelector("#rereg");
        ui.confOS = ui.conf.querySelector("#regconfos");
        ui.go = {
            win: ui.conf.querySelector("#goWindows"),
            mac: ui.conf.querySelector("#goMac"),
            lin: ui.conf.querySelector("#goLinux"),
            src: ui.conf.querySelector("#goSource")
        };
        ui.dlnotice = exports.node.querySelector("#dlnotice");
        ui.files = exports.node.querySelector("#files");
        ui.dl = exports.node.querySelector("#dl");

        ui.regBtn.addEventListener('click', doReg);
        ui.regName.addEventListener('keypress', function (e) {
            var key = e.which || e.keyCode;
            if ( key === 13 ) {
                ui.regEmail.focus();
            }
        });
        ui.regEmail.addEventListener('keypress', function (e) {
            var key = e.which || e.keyCode;
            if ( key === 13 ) {
                doReg();
            }
        });
        ui.rereg.addEventListener('click', reReg);
        ['win', 'lin', 'mac', 'src'].forEach(function(tag) {
            ui.go[tag].addEventListener('click', function() {
                showOs(tag);
            });
        });

        readReg();

        // read hash: e.g. '#os=win' or '#f=qubnews.txt'
        var hash = readHash();
        if ( hash.os ) {
            os = hash.os;
        } else if ( hash.f && hash.f.indexOf(".dmg") > 0 ) {
            os = 'mac';
        } else if ( hash.f && hash.f.indexOf(".exe") > 0 ) {
            os = 'win';
        } else if ( hash.f && hash.f.indexOf(".deb") > 0 ) {
            os = 'lin';
        } else if ( hash.f && hash.f.indexOf(".zip") > 0 ) {
            os = 'src';
        } else if ( navigator.appVersion.indexOf("Windows") >= 0 ) {
            os = 'win';
        } else if ( navigator.appVersion.indexOf("MacOS") >= 0 ) {
            os = 'mac';
        } else if ( navigator.appVersion.indexOf("X11") >= 0 ) {
            os = 'lin';
        } else {
            os = localStorage.getItem('qubdl_os') || os;
        }
        if ( hash.f ) {
            deferredFile = hash.f;
        }
        
        if ( ui.regName.value && ui.regEmail.value ) {
            enterConf();
        } else {
            enterReg();
        }
    };

    function readHash() {
        var hash = {};
        document.location.hash.slice(1).split('&').forEach(function(pair) {
            var lr = pair.split("=");
            if ( lr.length === 2 ) {
                hash[lr[0]] = lr[1];
            }
        });
        return hash;
    }

    function readReg() {
        ui.regName.value = localStorage.getItem("qubdl_name");
        ui.regEmail.value = localStorage.getItem("qubdl_email");
    }
    function saveReg() {
        localStorage.setItem("qubdl_name", ui.regName.value);
        localStorage.setItem("qubdl_email", ui.regEmail.value);
    }
    function sendReg() {
        post('reg', {
            name: ui.regName.value,
            email: ui.regEmail.value,
            date: (new Date()).strftime('%Y%m%d%H%M%S')
        });
    }

    function doReg() {
        if ( ! ui.regName.value ) {
            ui.regWarn.innerHTML = "Please enter your name";
            return;
        }
        if ( ui.regEmail.value.indexOf("@") < 1 ) {
            ui.regWarn.innerHTML = "Please enter your email address";
            return;
        }
        saveReg();
        enterConf();
    }

    function reReg() {
        ui.regName.value = '';
        ui.regEmail.value = '';
        saveReg();
        enterReg();
    }
    
    function enterReg() {
        ui.reg.className = '';
        ui.conf.className = 'hidden';
    }
    
    function enterConf() {
        sendReg();
        showOs(os);
        ui.reg.className = 'hidden';
        ui.conf.className = '';
        ui.confName.innerHTML = ui.regName.value;
        ui.confEmail.innerHTML = ui.regEmail.value;
        if ( deferredFile ) {
            downloadFile(deferredFile);
            deferredFile = '';
        }
    }

    function downloadFile(fname) {
        post('regFile', {
            name: ui.regName.value,
            email: ui.regEmail.value,
            date: (new Date()).strftime('%Y%m%d%H%M%S'),
            filename: fname
        });
        ui.dl.href = '../dl/'+fname;
        ui.dl.download = fname;
        ui.dl.click();
    }

    function showOs(os) {
        localStorage.setItem('qubdl_os', os);
        ui.dlnotice.innerHTML = notice[os];
        ui.confOS.innerHTML = osLabel[os];
        ui.files.innerHTML = "Loading...";
        post('listFiles', {
            os: os
        }).then(function(response) {
            ui.files.innerHTML = "";
            var entries = d3.select(ui.files)
                .selectAll("div")
                .data(response.files)
                .enter().append("div");
            entries.classed("dlentry", true);
            var dltable = entries.append("table");
            dltable.classed("dlhead", true);
            var dlhead = dltable.append("tr");
            var dlcell = dlhead.append("td");
            dlcell.classed("dltitle", true);
            dlcell.append("a")
                .attr("href", "#")
                .text(function(d, i) {
                    return d.name;
                })
                .on('click', function(d, i) {
                    downloadFile(d.filename)
                });
            var dlup = dlcell.append("span");
            dlup.classed("hidden", function(d, i) {
                return ! d.upgrade;
            });
            dlup.classed("dlupgrade", true);
            dlup.append("a")
                .attr("href", "#")
                .text("Upgrade")
                .on('click', function(d, i) {
                    downloadFile(d.upgrade);
                })
            dlup.append("span")
                .text(function(d, i) {
                    return d.upgrade && (' from v'+(d.upgradeSince)+' or newer') || "";
                });
            var cell = dlhead.append("td");
            cell.classed("dlsize", true);
            cell.text(function(d, i) {
                return ''+(d.size.toFixed(1))+' MB '+(d.ext);
            });
            cell = dlhead.append("td");
            cell.classed("dldate", true);
            cell.text(function(d, i) {
                return d.date;
            });
            cell = dlhead.append("td");
            cell.classed("dlversion", true);
            cell.text(function(d, i) {
                return d.version;
            });
            cell = entries.append("div");
            cell.classed("dldescription", true);
            cell.text(function(d, i) {
                return d.description;
            });
            var dlfootbox = entries.append("div");
            dlfootbox.classed("dlfoot", true);
            var dlfoottable = dlfootbox.append("table");
            dlfoottable.classed("hchoice", true);
            var dlfoot = dlfoottable.append("tr");
            dlfoot.append("td")
                .append("a")
                .attr("href", function(d, i) {
                    return '../'+d.aboutUrl;
                })
                .text("[about...]");
            dlfoot.append("td")
                .append("a")
                .attr("href", "#")
                .text("[older versions...]")
                .on('click', function(d, i) {
                    var prevsList = d3.select("#"+d.code);
                    prevsList.node().innerHTML = "Loading...";
                    post("listPrev", {
                        os: os,
                        code: d.code
                    }).then(function(prevs) {
                        prevsList.node().innerHTML = "";
                        var prevEntries = prevsList.selectAll("li")
                            .data(prevs.files);
                        var newEntry = prevEntries.enter().append("li");
                        var newLink = newEntry.append("a")
                            .attr("href", "#")
                            .on('click', function(d, i) {
                                downloadFile(d.filename)
                            });
                        var newSpan = newLink.append("span");
                        newSpan.classed("dltitle", true);
                        newSpan.text(function(d, i) {
                            return d.name;
                        });
                        newSpan = newLink.append("span");
                        newSpan.classed("dlversion", true);
                        newSpan.text(function(d, i) {
                            return ' '+d.version;
                        });
                        newSpan = newEntry.append("span");
                        newSpan.classed("dldate", true);
                        newSpan.text(function(d, i) {
                            return ' '+d.date;
                        });
                        prevEntries.exit().remove();
                    });
                });
            dlfoot.append("td")
                .append("a")
                .attr("href", function(d, i) {
                    return '../'+d.changelogUrl;
                })
                .text("[change log]");
            var prevbox = entries.append("div");
            prevbox.classed("dlprev", true);
            prevbox.append("ul")
                .attr('id', function(d, i) {
                    return d.code;
                });
        });
    }

    function post(method, data) {
        return new Promise(function(resolve, reject) {
            var request = new XMLHttpRequest();
            request.open('POST', method, true);
            request.onload = function() {
                var response = JSON.parse(request.responseText||'{"t": "Error", "msg": "Empty response"}');
                if ( response.t === 'Error' ) {
                    reject(response.msg);
                } else {
                    resolve(response);
                }
            };
            request.onerror = function(err) { reject(err); };
            request.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            request.send(JSON.stringify(data));
        });
    }

    notice = {
        win: '<b>Required:</b> first download and install <a href="../download#f=vcredist_x86.exe">Microsoft redistributable libraries</a><hr>',
        src: 'See the <a href="http://www.qub.buffalo.edu/wiki/index.php/Developers">Developers</a> page for repository instructions<hr>',
        mac: '<b>OS X 10.8 Mountain Lion and newer:</b> You may see a message when you open the program that it "'+"can't"+' be opened because it is from an unidentified developer" To become an identified developer requires paying a yearly fee to Apple, which is not reasonable for free software. Fortunately, you can avoid this message:'+" <b><i>Don't open the application with a double click. Click it while pressing the Control key instead,</i></b> then choose"+' "Open." <a href="http://support.apple.com/kb/HT5290">[more info at apple.com]</a><hr>',
        lin: ''
    };

    return exports;
});
