// testing node-ffi compute

var requirejs = require('requirejs');

requirejs.config({
    //Pass the top-level main.js/index.js require
    //function to requirejs so that node modules
    //are loaded relative to the top-level JS file.
    nodeRequire: require,
    paths: {
        "qubx_lib": "static/js/qubx_lib"
    }
});

requirejs(['qubx_lib'], function(qubx_lib) {
    qubx_lib.then(function(lib) {
        console.log(lib.expm([[-10, 10], [100, -100]], .1));
    });
});
