// server main

const requirejs = require('requirejs');

requirejs.config({
    //Pass the top-level main.js/index.js require
    //function to requirejs so that node modules
    //are loaded relative to the top-level JS file.
    nodeRequire: require,

    map: {
        "*": {
            "jquery" : "jquery_adapter"
        }
    }
});

requirejs(['server', 'qubsite'], (server, qubsite) => {
    qubsite.setup(server.app);
    server.run();
});
