CREATE DATABASE Models;
GRANT SELECT, INSERT, DELETE, UPDATE ON Models.* TO Models@'localhost' IDENTIFIED BY 'jihqprewgop';
USE Models;
CREATE TABLE Person (personId INT PRIMARY KEY AUTO_INCREMENT, personName VARCHAR(128), personAbout TEXT, personEmail VARCHAR(64), personActive BOOLEAN, personCanSave BOOLEAN, personCanSelfInvite BOOLEAN, personCanAdmin BOOLEAN, personCanInvite BOOLEAN);
CREATE TABLE Signin (signinId INT PRIMARY KEY AUTO_INCREMENT, signinPerson INT, signinSecret VARCHAR(36), INDEX(signinSecret), signinWhen DATETIME, signinIP VARCHAR(64), signinAgent VARCHAR(128));
CREATE TABLE Invite (inviteId INT PRIMARY KEY AUTO_INCREMENT, invitePerson INT, inviteSecret VARCHAR(36), inviteExpires DATETIME, inviteUsesRemain INT);
CREATE TABLE Model (modelId INT PRIMARY KEY AUTO_INCREMENT, modelName VARCHAR(128), modelQmj TEXT, modelAbout TEXT, modelDOI VARCHAR(128), modelPerson INT, modelWhenAdded DATETIME, modelWhenPub DATETIME, modelAuthors TEXT, modelStates INT, modelClasses INT, modelDigest TEXT);
CREATE TABLE LinkModel (linkId INT PRIMARY KEY AUTO_INCREMENT, linkKey VARCHAR(36), modelName VARCHAR(128), modelQmj TEXT, modelAbout TEXT, linkPerson INT, linkWhenAdded DATETIME);
CREATE TABLE Simulation (simId INT PRIMARY KEY AUTO_INCREMENT, simName VARCHAR(128), simConfig TEXT, simModel INT, simAbout TEXT);
